diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14/kernel/vserver/Kconfig linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/Kconfig
--- linux-2.6.16-vs2.1.1-rc14/kernel/vserver/Kconfig	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/Kconfig	2006-03-23 23:10:54 +0100
@@ -2,21 +2,6 @@
 # Linux VServer configuration
 #
 
-config	VSERVER
-	bool
-	default y
-
-config	VSERVER_SECURITY
-	bool
-	depends on SECURITY
-	default y
-	select SECURITY_CAPABILITIES
-
-config	VSERVER_LEGACYNET
-	bool
-	depends on !VSERVER_NGNET
-	default y
-
 menu "Linux VServer"
 
 config	VSERVER_LEGACY
@@ -216,3 +201,19 @@ config	VSERVER_HISTORY_SIZE
 
 endmenu
 
+
+config	VSERVER
+	bool
+	default y
+
+config	VSERVER_SECURITY
+	bool
+	depends on SECURITY
+	default y
+	select SECURITY_CAPABILITIES
+
+config	VSERVER_LEGACYNET
+	bool
+	depends on !VSERVER_NGNET
+	default y
+
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14/kernel/vserver/init.c linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/init.c
--- linux-2.6.16-vs2.1.1-rc14/kernel/vserver/init.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/init.c	2006-03-24 00:55:28 +0100
@@ -9,7 +9,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/errno.h>
 #include <linux/init.h>
 #include <linux/module.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14/kernel/vserver/vci_config.h linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/vci_config.h
--- linux-2.6.16-vs2.1.1-rc14/kernel/vserver/vci_config.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.1/kernel/vserver/vci_config.h	2006-03-24 00:05:48 +0100
@@ -1,7 +1,4 @@
 
-#include <linux/config.h>
-
-
 enum {
 	VCI_KCBIT_LEGACY = 1,
 	VCI_KCBIT_LEGACYNET,
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/drivers/block/vroot.c linux-2.6.16-vs2.1.1-rc14.3/drivers/block/vroot.c
--- linux-2.6.16-vs2.1.1-rc14.2/drivers/block/vroot.c	2006-03-20 17:34:49 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/drivers/block/vroot.c	2006-03-24 04:43:22 +0100
@@ -12,7 +12,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/moduleparam.h>
 #include <linux/file.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vs_memory.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vs_memory.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vs_memory.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vs_memory.h	2006-03-24 04:43:40 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_VS_MEMORY_H
 #define _VX_VS_MEMORY_H
 
-#include <linux/config.h>
 #include "vserver/limit.h"
 #include "vserver/debug.h"
 #include "vserver/limit_int.h"
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vs_sched.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vs_sched.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vs_sched.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vs_sched.h	2006-03-24 04:43:47 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_VS_SCHED_H
 #define _VX_VS_SCHED_H
 
-#include <linux/config.h>
 #include "vserver/sched.h"
 
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/context.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/context.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/context.h	2006-03-24 03:35:26 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/context.h	2006-03-24 04:44:03 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_CONTEXT_H
 #define _VX_CONTEXT_H
 
-#include <linux/config.h>
 #include <linux/types.h>
 
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/cvirt_def.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/cvirt_def.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/cvirt_def.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/cvirt_def.h	2006-03-24 04:44:10 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_CVIRT_DEF_H
 #define _VX_CVIRT_DEF_H
 
-#include <linux/config.h>
 #include <linux/jiffies.h>
 #include <linux/utsname.h>
 #include <linux/spinlock.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/debug.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/debug.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/debug.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/debug.h	2006-03-24 04:44:16 +0100
@@ -1,8 +1,6 @@
 #ifndef _VX_DEBUG_H
 #define _VX_DEBUG_H
 
-#include <linux/config.h>
-
 
 #define VXD_CBIT(n,m)	(vx_debug_ ## n & (1 << (m)))
 #define VXD_CMIN(n,m)	(vx_debug_ ## n > (m))
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/dlimit_cmd.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/dlimit_cmd.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/dlimit_cmd.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/dlimit_cmd.h	2006-03-24 04:44:23 +0100
@@ -1,8 +1,6 @@
 #ifndef _VX_DLIMIT_CMD_H
 #define _VX_DLIMIT_CMD_H
 
-#include <linux/config.h>
-
 
 /*  dlimit vserver commands */
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/inode.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/inode.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/inode.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/inode.h	2006-03-24 04:44:30 +0100
@@ -15,8 +15,6 @@
 
 #ifdef	__KERNEL__
 
-#include <linux/config.h>
-
 
 #ifdef	CONFIG_VSERVER_PROC_SECURE
 #define IATTR_PROC_DEFAULT	( IATTR_ADMIN | IATTR_HIDE )
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/inode_cmd.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/inode_cmd.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/inode_cmd.h	2006-03-20 17:34:50 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/inode_cmd.h	2006-03-24 04:44:42 +0100
@@ -28,8 +28,6 @@ struct	vcmd_ctx_iattr_v1 {
 
 #ifdef	__KERNEL__
 
-#include <linux/config.h>
-
 
 #ifdef	CONFIG_COMPAT
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/limit_def.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/limit_def.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/limit_def.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/limit_def.h	2006-03-24 04:44:49 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_LIMIT_DEF_H
 #define _VX_LIMIT_DEF_H
 
-#include <linux/config.h>
 #include <asm/atomic.h>
 #include <asm/resource.h>
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/sched_def.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/sched_def.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/sched_def.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/sched_def.h	2006-03-24 04:44:55 +0100
@@ -1,7 +1,6 @@
 #ifndef _VX_SCHED_DEF_H
 #define _VX_SCHED_DEF_H
 
-#include <linux/config.h>
 #include <linux/spinlock.h>
 #include <linux/jiffies.h>
 #include <linux/cpumask.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/tag.h linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/tag.h
--- linux-2.6.16-vs2.1.1-rc14.2/include/linux/vserver/tag.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/include/linux/vserver/tag.h	2006-03-24 04:45:01 +0100
@@ -1,8 +1,6 @@
 #ifndef _DX_TAG_H
 #define _DX_TAG_H
 
-#include <linux/config.h>
-
 
 #define DX_TAG(in)	(IS_TAGGED(in))
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/context.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/context.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/context.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/context.c	2006-03-24 04:45:09 +0100
@@ -21,7 +21,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/types.h>
 #include <linux/namespace.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/cvirt_init.h linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/cvirt_init.h
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/cvirt_init.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/cvirt_init.h	2006-03-24 04:45:15 +0100
@@ -1,6 +1,4 @@
 
-#include <linux/config.h>
-
 
 extern uint64_t vx_idle_jiffies(void);
 
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/dlimit.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/dlimit.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/dlimit.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/dlimit.c	2006-03-24 04:45:21 +0100
@@ -10,7 +10,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/fs.h>
 #include <linux/namespace.h>
 #include <linux/namei.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/helper.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/helper.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/helper.c	2006-03-20 17:34:50 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/helper.c	2006-03-24 04:45:30 +0100
@@ -9,7 +9,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/errno.h>
 #include <linux/kmod.h>
 #include <linux/sched.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/history.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/history.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/history.c	2006-03-20 17:34:50 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/history.c	2006-03-24 04:45:39 +0100
@@ -11,7 +11,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/errno.h>
 #include <linux/module.h>
 #include <linux/types.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/inode.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/inode.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/inode.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/inode.c	2006-03-24 04:45:55 +0100
@@ -9,7 +9,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/sched.h>
 #include <linux/vs_context.h>
 #include <linux/proc_fs.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/limit_init.h linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/limit_init.h
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/limit_init.h	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/limit_init.h	2006-03-24 04:46:01 +0100
@@ -1,6 +1,4 @@
 
-#include <linux/config.h>
-
 
 static inline void vx_info_init_limit(struct _vx_limit *limit)
 {
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/network.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/network.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/network.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/network.c	2006-03-24 04:46:12 +0100
@@ -13,7 +13,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/vserver/network_cmd.h>
 #include <linux/rcupdate.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/sched.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/sched.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/sched.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/sched.c	2006-03-24 04:46:31 +0100
@@ -10,7 +10,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/sched.h>
 #include <linux/vs_context.h>
 #include <linux/vs_sched.h>
diff -NurpP --minimal linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/switch.c linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/switch.c
--- linux-2.6.16-vs2.1.1-rc14.2/kernel/vserver/switch.c	2006-03-20 18:09:05 +0100
+++ linux-2.6.16-vs2.1.1-rc14.3/kernel/vserver/switch.c	2006-03-24 04:46:40 +0100
@@ -14,7 +14,6 @@
  *
  */
 
-#include <linux/config.h>
 #include <linux/linkage.h>
 #include <linux/sched.h>
 #include <linux/compat.h>