diff -NurpP --minimal util-vserver-0.30.207-c/Makefile.in util-vserver-0.30.207-devc/Makefile.in
--- util-vserver-0.30.207-c/Makefile.in	2005-04-28 21:12:26.000000000 +0200
+++ util-vserver-0.30.207-devc/Makefile.in	2005-05-03 05:49:56.000000000 +0200
@@ -1837,6 +1837,7 @@ man_pages = man/chbind.8 \
 
 scripts_pkglib_src_DTA = scripts/functions \
 				scripts/vserver-build.apt-rpm \
+				scripts/vserver-build.clone \
 				scripts/vserver-build.skeleton \
 				scripts/vserver-build.debootstrap \
 				scripts/vserver-build.rpm \
@@ -1861,6 +1862,8 @@ scripts_pkglib_src_SCRPTS = scripts/pkgm
 				scripts/start-vservers \
 				scripts/vprocunhide \
 				scripts/vserver-build \
+				scripts/vserver-destroy \
+				scripts/vserver-reconfig \
 				scripts/vserver-wrapper \
 				scripts/vservers.grabinfo.sh \
 				scripts/vshelper \
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/util-vserver-vars.pathsubst util-vserver-0.30.207-devc/scripts/util-vserver-vars.pathsubst
--- util-vserver-0.30.207-c/scripts/util-vserver-vars.pathsubst	2005-03-23 03:05:39.000000000 +0100
+++ util-vserver-0.30.207-devc/scripts/util-vserver-vars.pathsubst	2005-05-03 05:55:57.000000000 +0200
@@ -82,6 +82,8 @@ _VSCHED="$__SBINDIR/vsched"
 _VSERVER="$__SBINDIR/vserver"
 _VSERVER_LEGACY="$__LEGACYDIR/vserver"
 _VSERVER_BUILD="$__PKGLIBDIR/vserver-build"
+_VSERVER_RECONFIG="$__PKGLIBDIR/vserver-reconfig"
+_VSERVER_DESTROY="$__PKGLIBDIR/vserver-destroy"
 _VSERVER_INFO="$__SBINDIR/vserver-info"
 _VSERVERKILLALL="$__LEGACYDIR/vserverkillall"
 _VSHELPER="$__PKGLIBDIR/vshelper"
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/vserver util-vserver-0.30.207-devc/scripts/vserver
--- util-vserver-0.30.207-c/scripts/vserver	2005-04-28 20:03:42.000000000 +0200
+++ util-vserver-0.30.207-devc/scripts/vserver	2005-05-03 05:55:13.000000000 +0200
@@ -57,6 +57,9 @@ Possible commands are:
 
     build <buildopts>*
                 ... builds a new vserver from scratch
+    reconfig <configopts>*
+		... reconfigures an existing vserver guest
+    destroy 	... destroy existing vserver guest
 
     unify [-R]
 		... (de)unify vserver
@@ -152,8 +155,14 @@ SELF=( "$0" "${OPTION_ALL[@]}" )
 vserver=$1
 cmd=$2
 
-test "$cmd" != build || { shift 2; exec "$_VSERVER_BUILD" -n "$vserver" "$@"; }
+test "$cmd" != "build" \
+	|| { shift 2; exec "$_VSERVER_BUILD" -n "$vserver" "$@"; }
 
+test "$cmd" != "reconfig" \
+	|| { shift 2; exec "$_VSERVER_RECONFIG" -n "$vserver" "$@"; }
+
+test "$cmd" != "destroy" \
+	|| { shift 2; exec "$_VSERVER_DESTROY" -n "$vserver" "$@"; }
 
 allow_legacy=
 
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/vserver-build util-vserver-0.30.207-devc/scripts/vserver-build
--- util-vserver-0.30.207-c/scripts/vserver-build	2005-03-21 21:03:31.000000000 +0100
+++ util-vserver-0.30.207-devc/scripts/vserver-build	2005-05-03 05:52:48.000000000 +0200
@@ -50,6 +50,8 @@ Possible methods are:
 		     cfg-options will be ignored
     copy        ...  the copy-all-from-host method which uses the recent
                      configuration scheme
+    clone       ...  clone an existing vserver guest
+
     apt-rpm ... -- -d <distribution>
                 ...  installs the base-packages of the given distribution with
 		     help of 'vapt-get'
@@ -121,7 +123,7 @@ setup_setDefaults "$VSERVER_NAME"
 
 case x"$method" in
     (xlegacy)	exec $_VSERVER_LEGACY "$VSERVER_NAME" build "$@" ;;
-    (xapt-rpm|xcopy|xskeleton|xdebootstrap|xyum|xrpm)
+    (xapt-rpm|xcopy|xclone|xskeleton|xdebootstrap|xyum|xrpm)
 		. $__PKGLIBDIR/vserver-build.$method
 		;;
     (x)		panic $"No build-method specified";;
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/vserver-build.clone util-vserver-0.30.207-devc/scripts/vserver-build.clone
--- util-vserver-0.30.207-c/scripts/vserver-build.clone	1970-01-01 01:00:00.000000000 +0100
+++ util-vserver-0.30.207-devc/scripts/vserver-build.clone	2005-05-03 06:01:24.000000000 +0200
@@ -0,0 +1,51 @@
+# Copyright (C) 2005 Herbert Pötzl <herbert@13thfloor.at>
+# based on vserver-build.skeleton from Enrico Scholz 
+#  
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#  
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#  
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+tmp=$(getopt -o '+d:' --long debug,pkgmgmt -n "$0" -- "$@") || exit 1
+eval set -- "$tmp"
+
+. "$_LIB_VSERVER_BUILD_FUNCTIONS_PKGMGMT"
+
+DISTRIBUTION=:
+use_pkgmgmt=
+while true; do
+    case "$1" in
+	-d)		DISTRIBUTION=$2; shift;;
+	--debug)	set -x;;
+	--pkgmgmt)	use_pkgmgmt=1;;
+	--)		shift; break ;;
+	*)		echo "vserver-build.clone: internal error: unrecognized option '$1'" >&2
+			exit 1
+			;;
+    esac
+    shift
+done
+
+getDistribution
+
+base.initVariables
+test -z "$use_pkgmgmt" || pkgmgmt.initVariables
+
+base.initFilesystem "$OPTION_FORCE"
+test -z "$use_pkgmgmt" || pkgmgmt.initFilesystem "$OPTION_FORCE"
+
+
+setup_writeOption "$VSERVER_NAME"
+setup_writeInitialFstab
+
+test -z "$BUILD_INITPRE"  || "$BUILD_INITPRE" "$SETUP_CONFDIR"  "$UTIL_VSERVER_VARS"
+test -z "$1" || "$@"
+test -z "$BUILD_INITPOST" || "$BUILD_INITPOST" "$SETUP_CONFDIR" "$UTIL_VSERVER_VARS"
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/vserver-destroy util-vserver-0.30.207-devc/scripts/vserver-destroy
--- util-vserver-0.30.207-c/scripts/vserver-destroy	1970-01-01 01:00:00.000000000 +0100
+++ util-vserver-0.30.207-devc/scripts/vserver-destroy	2005-05-03 06:00:47.000000000 +0200
@@ -0,0 +1,90 @@
+#! /bin/bash
+
+# Copyright (C) 2005 Herbert Pötzl <herbert@13thfloor.at>
+# based on vserver-build from Enrico Scholz 
+#  
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#  
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#  
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+: ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
+test -e "$UTIL_VSERVER_VARS" || {
+    echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
+    exit 1
+}
+. "$UTIL_VSERVER_VARS"
+. "$_LIB_FUNCTIONS"
+. "$_LIB_VSERVER_SETUP_FUNCTIONS"
+. "$_LIB_VSERVER_BUILD_FUNCTIONS"
+
+### Some local functions
+
+function showHelp()
+{
+    echo \
+$"Usage: $(basename $0) -n <name> --force
+
+Options:
+    --force     ...  destroy existing vservers with force
+      
+Please report bugs to $PACKAGE_BUGREPORT"
+    exit 0
+}
+
+function showVersion()
+{
+    echo \
+$"vserver-destroy $PACKAGE_VERSION -- destroys a vserver
+This program is part of $PACKAGE_STRING
+
+Copyright (C) 2005 Herbert Pötzl
+This program is free software; you may redistribute it under the terms of
+the GNU General Public License.  This program has absolutely no warranty."
+    exit 0
+}
+
+### main starts here
+
+set -e
+
+declare -a default_opts=()
+test -n "$NO_DEFAULT_OPTS" || getFileArray default_opts "$__CONFDIR/.defaults/apps/build/options" || :
+
+tmp=$(getopt -o +m:n: --long force,debug,help,version,$SETUP_OPTIONS -n "$(basename $0)" -- \
+	"${default_opts[@]}" "$@") || exit 1
+eval set -- "$tmp"
+
+VSERVER_NAME=
+OPTION_FORCE=
+OPTION_DEBUG=0
+
+while true; do
+    case "$1" in
+	(--help)    showHelp $0 ;;
+	(--version) showVersion ;;
+	(--force)   OPTION_FORCE=1;;
+	(--debug)   let ++OPTION_DEBUG;  set -x;;
+	(-n)	    VSERVER_NAME=$2; shift;;
+	(--)	    shift; break;;
+	(*)
+	    { setup_setOption2 "$1" "$2" && shift; } || \
+	      panic $"vserver-destroy: internal error."
+	    ;;
+    esac
+    shift
+done
+
+test -n "$VSERVER_NAME" ||
+    panic $"Name of vserver not specified"
+
+setup_setDefaults "$VSERVER_NAME"
+
diff -NurpP --minimal util-vserver-0.30.207-c/scripts/vserver-reconfig util-vserver-0.30.207-devc/scripts/vserver-reconfig
--- util-vserver-0.30.207-c/scripts/vserver-reconfig	1970-01-01 01:00:00.000000000 +0100
+++ util-vserver-0.30.207-devc/scripts/vserver-reconfig	2005-05-03 06:00:21.000000000 +0200
@@ -0,0 +1,92 @@
+#! /bin/bash
+
+# Copyright (C) 2005 Herbert Pötzl <herbert@13thfloor.at>
+# based on vserver-build from Enrico Scholz 
+#  
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#  
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#  
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+: ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
+test -e "$UTIL_VSERVER_VARS" || {
+    echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
+    exit 1
+}
+. "$UTIL_VSERVER_VARS"
+. "$_LIB_FUNCTIONS"
+. "$_LIB_VSERVER_SETUP_FUNCTIONS"
+. "$_LIB_VSERVER_BUILD_FUNCTIONS"
+
+### Some local functions
+
+function showHelp()
+{
+    echo \
+$"Usage: $(basename $0) -m <method> -n <name> --force <cfg-options>*
+
+Options:
+    --force     ...  reconfig vserver guest with force
+      
+cfg-options are: $SETUP_HELPMSG
+
+Please report bugs to $PACKAGE_BUGREPORT"
+    exit 0
+}
+
+function showVersion()
+{
+    echo \
+$"vserver-reconfig $PACKAGE_VERSION -- reconfigures a vserver
+This program is part of $PACKAGE_STRING
+
+Copyright (C) 2005 Herbert Pötzl
+This program is free software; you may redistribute it under the terms of
+the GNU General Public License.  This program has absolutely no warranty."
+    exit 0
+}
+
+### main starts here
+
+set -e
+
+declare -a default_opts=()
+test -n "$NO_DEFAULT_OPTS" || getFileArray default_opts "$__CONFDIR/.defaults/apps/build/options" || :
+
+tmp=$(getopt -o +m:n: --long force,debug,help,version,rootdir:,pkgbase:,$SETUP_OPTIONS -n "$(basename $0)" -- \
+	"${default_opts[@]}" "$@") || exit 1
+eval set -- "$tmp"
+
+VSERVER_NAME=
+OPTION_FORCE=
+OPTION_DEBUG=0
+
+while true; do
+    case "$1" in
+	(--help)    showHelp $0 ;;
+	(--version) showVersion ;;
+	(--force)   OPTION_FORCE=1;;
+	(--debug)   let ++OPTION_DEBUG;  set -x;;
+	(-n)	    VSERVER_NAME=$2; shift;;
+	(--)	    shift; break;;
+	(*)
+	    { setup_setOption2 "$1" "$2" && shift; } || \
+	      panic $"vserver-reconfig: internal error."
+	    ;;
+    esac
+    shift
+done
+
+test -n "$VSERVER_NAME" ||
+    panic $"Name of vserver not specified"
+
+setup_setDefaults "$VSERVER_NAME"
+